;========================= MACROSES =========================
LABEL_EXPR			equ 00000001b					;  
MEM_EXPR			equ 00000010b					; 
IMM_EXPR			equ 00000100b					;  
DIRECT_ADDR			equ 00001000b					;   
REG_EXPR			equ 00010000b					; 
VALID_REF			equ 00100000b					;  
MEM_SS_EXPR			equ 01000000b					;   SS 
EXTER_LABEL_EXPR	equ 10000000b					;  
VIMM_EXPR			equ (VALID_REF OR IMM_EXPR)		; 

true				equ 1
false				equ 0
TRUE				equ 1
FALSE				equ 0
NULL				equ 0

align_proc MACRO
LOCAL m1,m2
IFNDEF __MINIMAL_SIZE__
m1:	align 16
m2:	org		m1
	db		15 dup (0CCh)
	org		m2
ENDIF
ENDM

align_data MACRO
IFNDEF __MINIMAL_SIZE__
	align 4
ENDIF
ENDM

START_PROFILER MACRO timer:req
	push	ebx
	xor		eax, eax
	cpuid
	rdtsc
	mov		dword ptr timer[0], eax
	mov		dword ptr timer[4], edx
	xor		eax, eax
	cpuid
	pop		ebx
	EXITM <>
ENDM

STOP_PROFILER MACRO timer:req, over_head:req
	push	ebx
	xor		eax, eax
	cpuid
	rdtsc
	pop		ebx
	sub		eax, dword ptr timer[0]
	sbb		edx, dword ptr timer[4]
	sub		eax, over_head
	sbb		edx, 0
	mov		dword ptr timer[0], eax
	mov		dword ptr timer[4], edx
	EXITM <>
ENDM

uinvoke777 MACRO func:REQ, args:VARARG
;;	% echo @CatStr(args)
	IFB <args>
		invoke func
	ELSE
		invoke func, args
	ENDIF
;;	% echo @CatStr(%@LastReturnType)
	IF (@LastReturnType EQ 0) OR (@LastReturnType EQ 0x40)
		EXITM <al>
	ELSEIF (@LastReturnType EQ 1) OR (@LastReturnType EQ 0x41)
		EXITM <ax>
	ELSEIF (@LastReturnType EQ 2) OR (@LastReturnType EQ 0x42)
		EXITM <eax>
	ELSEIF (@LastReturnType EQ 6) OR (@LastReturnType EQ 0x22) OR (@LastReturnType EQ 0x23)
		EXITM <xmm0>
	ELSE
		.err <Unknown LastReturnType>
	ENDIF
ENDM

mrm MACRO FirstArgument:REQ, SecondArgument:REQ
LOCAL itemSize
	itemSize=TYPE (FirstArgument)
	IF itemSize EQ 1
		mov		al, SecondArgument
		mov		FirstArgument, al
	ELSEIF itemSize EQ 2
		itemSize=TYPE (SecondArgument)
		IF (itemSize EQ 2) or (itemSize EQ 0)
			mov		ax, SecondArgument
			mov		FirstArgument, ax
		ELSE
			movzx	eax, SecondArgument
			mov		FirstArgument, ax
		ENDIF
	ELSEIF itemSize EQ 16
		movups	xmm0, SecondArgument
		movups	FirstArgument, xmm0
	ELSE
		itemSize=TYPE (SecondArgument)
		IF (itemSize EQ 4) or (itemSize EQ 0)
			mov		eax, SecondArgument
			mov		FirstArgument, eax
		ELSE
			movzx	eax, SecondArgument
			mov		FirstArgument, eax
		ENDIF
	ENDIF
ENDM
m2m MACRO param1:req, param2:req
	push	param2
	pop		param1
ENDM

;    !
swap MACRO param1:req, param2:req
LOCAL itemSize, register1, register2
	itemSize=TYPE (param1)
	register1	TEXTEQU <>
	register2	TEXTEQU <>
	IF itemSize EQ 1
		register1	TEXTEQU <al>
		register2	TEXTEQU <dl>
	ELSEIF itemSize EQ 2
		register1	TEXTEQU <ax>
		register2	TEXTEQU <dx>
	ELSEIF itemSize EQ 4
		register1	TEXTEQU <eax>
		register2	TEXTEQU <edx>
;;	ELSEIF itemSize EQ 8
;;		register1	TEXTEQU <rax>
;;		register2	TEXTEQU <rdx>
	ENDIF
	mov		register1, param1
	mov		register2, param2
	mov		param2, register1
	mov		param1, register2
ENDM

acfm$ MACRO txt:VARARG
	LOCAL ch1,char,nu$,tmp,flag,lbuf,rbuf,cpos,sln
	ch1 equ <>
	nu$ equ <>
	flag = 0
	ch1 SUBSTR <txt>,1,1					;; check if 1st character is a quote
	IFDIF ch1,<">
		EXITM <txt>							;; exit with original "txt" if it is not
	ENDIF
	FORC char,<txt>							;; scan through characters in "txt"
		IFIDN <char>,<\>					;; increment the flag if "\" escape character
			flag = flag + 1
		ENDIF
		; -----------------------------------------------
		IF flag EQ 0						;; <<< if flag = 0 then normal APPEND character
			nu$ CATSTR nu$,<char>
		ENDIF
		IF flag EQ 1						;; <<< if flag = 1 then perform replacement
			IFIDN <char>,<n>
				nu$ CATSTR nu$,<",10,">		;; \n = LF
				flag = 0
			ENDIF
			IFIDN <char>,<r>
				nu$ CATSTR nu$,<",13,">		;; \r = CR
				flag = 0
			ENDIF
			IFIDN <char>,<t>
				nu$ CATSTR nu$,<",9,">		;; \t = TAB
				flag = 0
			ENDIF
			IFIDN <char>,<q>
				nu$ CATSTR nu$,<",34,">		;; \q = quote
				flag = 0
			ENDIF
			IFIDN <char>,<a>
				nu$ CATSTR nu$,<",7,">		;; \a = alarm
				flag = 0
			ENDIF
			IFIDN <char>,<b>
				nu$ CATSTR nu$,<",8,">		;; \b = backspace
				flag = 0
			ENDIF
			IFIDN <char>,<0>
				nu$ CATSTR nu$,<",0,">		;; \0 = embedded zero
				flag = 0
			ENDIF
			IFIDN <char>,<f>
				nu$ CATSTR nu$,<",12,">		;; \f = form feed
				flag = 0
			ENDIF
			IFIDN <char>,<v>
				nu$ CATSTR nu$,<",11,">		;; \f = vert. tab
				flag = 0
			ENDIF
			;; ---------------------
			;; masm specific escapes
			;; ---------------------
			IFIDN <char>,<{>
				nu$ CATSTR nu$,<",60,">		;; \{ = <
				flag = 0
			ENDIF
			IFIDN <char>,<}>
				nu$ CATSTR nu$,<",62,">		;; \} = >
				flag = 0
			ENDIF
			IFIDN <char>,<|>
				nu$ CATSTR nu$,<",33,">		;; \| = !
				flag = 0
			ENDIF
			IFIDN <char>,<[>
				nu$ CATSTR nu$,<",40,">		;; \[ = (
				flag = 0
			ENDIF
			IFIDN <char>,<]>
				nu$ CATSTR nu$,<",41,">		;; \] = )
				flag = 0
			ENDIF
		ENDIF
		IF flag EQ 2						;; <<< if flag = 2 APPEND the '\' character
			IFIDN <char>,<\>
				nu$ CATSTR nu$,<",92,">		;; \\ = '\'
				flag = 0
			ENDIF
		ENDIF
	ENDM
	;; ---------------------------------------------
	;; strip any embedded <"",> characters sequences
	;; ---------------------------------------------
	nu$ CATSTR nu$,<,0,0,0>					;; append trailing zeros
	cpos INSTR nu$,<"",>					;; test for leading junk
	IF cpos EQ 1
		nu$ SUBSTR nu$,4					;; chomp off any leading junk
	ENDIF
	cpos INSTR nu$,<"",>
	WHILE cpos
		lbuf SUBSTR nu$,1,cpos-1			;; read text before junk
		rbuf SUBSTR nu$,cpos+3				;; read text after junk
		nu$		equ <>						;; clear nu$
		nu$ CATSTR lbuf,rbuf				;; concantenate the two
		cpos INSTR nu$,<"",>				;; reload cpos for next iteration
	ENDM
	sln SIZESTR nu$
	nu$ SUBSTR nu$,1,sln-6					;; trim off tail padding
	.const
	align 4
	tmp		db nu$,0
	.code
	EXITM <OFFSET tmp>						;; return the DATA section OFFSET
ENDM

_static MACRO any_params:VARARG
.data
align 4
% any_params
.code
ENDM

static_str$ MACRO any_text:VARARG
LOCAL txtname
.data
align 4
txtname		db any_text, 0
.code
EXITM <offset txtname>
ENDM

static_float MACRO name_param:REQ, param:VARARG
.data
align 4
name_param		REAL4	param
.code
ENDM

const_static_float MACRO name_param:REQ, param:VARARG
.const
align 4
name_param		REAL4	param
.code
ENDM

const_static_float$ MACRO value:VARARG
LOCAL name_param
.const
align 4
name_param		REAL4	value
.code
EXITM <name_param>
ENDM
CFP4	textequ <const_static_float$>

const_static_double MACRO name_param:REQ, param:VARARG
.const
align 8
name_param		REAL8	param
.code
ENDM

const_static_double$ MACRO value:VARARG
LOCAL name_param
.const
align 8
name_param		REAL8	value
.code
EXITM <name_param>
ENDM
CFP8	textequ <const_static_double$>

static_xmm4 MACRO name_param:REQ, param:VARARG
.data
align 16
name_param		dd	param
.code
ENDM

const_static_xmm4 MACRO name_param:REQ, param:VARARG
.const
align 16
name_param		dd	param
.code
ENDM

static_int MACRO name_param:REQ, param:VARARG
.data
align 4
name_param		SDWORD	param
.code
ENDM

const_static_int MACRO name_param:REQ, param:VARARG
.const
align 4
name_param		DWORD	param
.code
ENDM

static_byte MACRO name_param:REQ, param:VARARG
.data
align 1
name_param		BYTE	param
.code
ENDM

const_static_byte MACRO name_param:REQ, param:VARARG
.const
align 1
name_param		BYTE	param
.code
ENDM

static_str MACRO name_param:REQ, param:VARARG
.data
align 4
name_param		byte	param, 0
.code
ENDM

const_static_str MACRO name_param:REQ, param:VARARG
.const
align 4
name_param		byte	param, 0
.code
ENDM

const_static_str$ MACRO any_text:VARARG
LOCAL txtname
.const
align 4
txtname		db any_text, 0
.code
EXITM <offset txtname>
ENDM

PURGE CSTR
CSTR MACRO text:VARARG
LOCAL txtname
.const
align 4
txtname		db text, 0
.code
EXITM <offset txtname>
ENDM

const_static_str_crlf$ MACRO any_text:VARARG
LOCAL txtname
.const
align 4
txtname		db any_text,13,10, 0
.code
EXITM <offset txtname>
ENDM

regvar MACRO reg:req, mem:req
LOCAL _mem
IF @InStr(1, <&mem>, <&>) EQ 1
	_mem equ @SubStr(<&mem>, 2)
;;	% echo @CatStr(%OPATTR (_mem))
	IF ((OPATTR _mem) AND DIRECT_ADDR)
		mov		reg, offset _mem
	ELSE
		lea		reg, _mem
	ENDIF
ELSEIF @InStr(1, <&mem>, <">) EQ 1
	mov		reg, acfm$(mem)
ELSEIFDIFI <reg>, <mem>
	mov		reg, mem
ENDIF
ENDM

pushvar MACRO mem:req
LOCAL _mem, ddd
IF @InStr(1, <&mem>, <&>) EQ 1
	_mem equ @SubStr(<&mem>, 2)
	IF ((OPATTR (_mem)) AND DIRECT_ADDR)
		push 	offset _mem
		globalCountPushBytes = globalCountPushBytes + 1
	ELSE
		lea		eax, _mem
		push	eax
		globalCountPushBytes = globalCountPushBytes + 1
	ENDIF
ELSEIF @InStr(1, <&mem>, <">) EQ 1
	push	acfm$(mem)
	globalCountPushBytes = globalCountPushBytes + 1
ELSEIF @InStr(1, <&mem>, <^>) EQ 1	;;casting float -> double
	_mem equ @SubStr(<&mem>, 2)
	push	_mem
	fld		dword ptr [esp]
	push	ecx
	fstp	qword ptr [esp]
	globalCountPushBytes = globalCountPushBytes + 2
ELSE
;;	% echo @CatStr(%OPATTR(mem))
	IF ((OPATTR(mem)) EQ 0)
		push	mem
		globalCountPushBytes = globalCountPushBytes + 1
	ELSEIF (TYPE(mem) EQ 2 OR TYPE(mem) EQ 1)
		movzx	eax, mem
		push	eax
		globalCountPushBytes = globalCountPushBytes + 1
	ELSEIF (TYPE(mem) EQ 8)
		push	dword ptr mem[4]
		push	dword ptr mem[0]
		globalCountPushBytes = globalCountPushBytes + 2
	ELSE
		push	mem
		globalCountPushBytes = globalCountPushBytes + 1
	ENDIF
ENDIF
ENDM

globalCountPushBytes		= 0	;;    
printflr MACRO fmt_txt:REQ, params:VARARG
LOCAL argstr, arg
	argstr TEXTEQU <>
	IFNB <params>
%		FOR arg, <params>
			argstr CATSTR <arg, >, argstr
		ENDM
		argstr SUBSTR argstr, 1, @SizeStr(%argstr)-2
	ENDIF
	globalCountPushBytes = 1
%	FOR arg, <argstr>
		pushvar	arg
	ENDM
;;% echo @CatStr(%globalCountPushBytes)
	push	const_static_str_crlf$(fmt_txt)
	call	crt_printf
	add		esp, globalCountPushBytes*4
	EXITM <>
ENDM

printf MACRO fmt_txt:REQ, params:VARARG
LOCAL argstr, arg
	argstr TEXTEQU <>
	IFNB <params>
%		FOR arg, <params>
			argstr CATSTR <arg, >, argstr
		ENDM
		argstr SUBSTR argstr, 1, @SizeStr(%argstr)-2
	ENDIF
	globalCountPushBytes = 0
%	FOR arg, <argstr>
		pushvar	arg
	ENDM
;;% echo @CatStr(%globalCountPushBytes)
	pushvar	fmt_txt
	call	crt_printf
	add		esp, globalCountPushBytes*4
	EXITM <>
ENDM

globalCountPushBytes		= 0	;;    
sprintf MACRO buffer:REQ, fmt_txt:REQ, args:VARARG
LOCAL argstr, arg
	IFNB <args>
		argstr TEXTEQU <>
%		FOR arg, <args>
			argstr CATSTR <arg, >, argstr
		ENDM
		argstr SUBSTR argstr, 1, @SizeStr(%argstr)-2
		globalCountPushBytes = 0
%		FOR arg, <argstr>
			pushvar	arg
		ENDM
	;;% echo @CatStr(%globalCountPushBytes)
		pushvar	fmt_txt
		pushvar	buffer
		call	crt_sprintf
		add		esp, globalCountPushBytes*4
;;		add		buffer, eax
	ELSE ;;
		regvar	ecx, fmt_txt
		regvar	edx, buffer
		.while (true)
			mov		al, [ecx]
			mov		[edx], al
			.break .if (al==0)
			inc		ecx
			inc		edx
		.endw
;;		mov		buffer, edx
	ENDIF
	EXITM <>
ENDM

return MACRO result
	% echo @CatStr(%result)
	IFNB <result>
		IF (@LastReturnType EQ 0) OR (@LastReturnType EQ 040h)
			IF (result EQ 0)
				xor		al, al
			ELSE
				mov		al, result
			ENDIF
		ELSEIF (@LastReturnType EQ 1) OR (@LastReturnType EQ 041h)
			IF (result EQ 0)
				xor		ax, ax
			ELSE
				mov		ax, result
			ENDIF
		ELSEIF (@LastReturnType EQ 2) OR (@LastReturnType EQ 042h)
			IF (result EQ 0)
				xor		eax, eax
			ELSE
				mov		eax, result
			ENDIF
		ELSEIF (@LastReturnType EQ 6) OR (@LastReturnType EQ 022h) OR (@LastReturnType EQ 023h)
			movups	xmm0, result
		ELSE
			.err <Unknown LastReturnType>
		ENDIF
	ENDIF
	ret
ENDM

RGB MACRO red:req, green:req, blue:req
	xor		eax, eax
	mov		ah, blue
	shl		eax, 8
	mov		ah, green
	mov		al, red
ENDM

;  
memcopy1 MACRO dest:req, source:req, count:req
	regvar	edi, dest
	regvar	esi, source
	regvar	ecx, count
	movsb
	EXITM <>
ENDM
;  
memcopy2 MACRO dest:req, source:req, count:req
	regvar	edi, dest
	regvar	esi, source
	regvar	ecx, count
	movsw
	EXITM <>
ENDM
;  
memcopy4 MACRO dest:req, source:req, count:req
	regvar	edi, dest
	regvar	esi, source
	regvar	ecx, count
	movsd
	EXITM <>
ENDM

@MEMSET MACRO Buf:req, value:req, count:req
	LOCAL pBuf, remainder
	push	edi
	IF @InStr(1, <&Buf>, <&>) EQ 1
		pBuf equ @SubStr(<&Buf>, 2)
		IF ((OPATTR pBuf) AND DIRECT_ADDR) OR ((OPATTR pBuf) AND LABEL_EXPR)
			mov	edi, offset pBuf
		ELSE
			lea	edi, pBuf
		ENDIF
	ELSEIFDIFI <Buf>, <edi>
		mov	edi, Buf
	ENDIF
	IF value EQ 0
	xor		eax, eax
	ELSEIFDIFI <value>,<eax>
	mov		eax, value
	ENDIF
	mov		ecx, count/4	;(count+3)/4	; count - bytes
	rep stosd
	remainder = count	;;
	remainder = remainder MOD 4
;;	% echo @CatStr(%count), @CatStr(%remainder)
	IF remainder GE 2
		mov		word ptr [edi], ax
	ENDIF
	IF (remainder MOD 2) EQ 1
		mov		byte ptr [edi], al
	ENDIF
	pop		edi
	EXITM <>
ENDM

CVIRTUAL MACRO name_method:REQ, langType:REQ, retType:REQ, protoDef:VARARG
LOCAL sz1, sz2
	pDef CATSTR <TYPEDEF PROTO >,<&langType&>,< (&retType&)>
	IFNB <protoDef>
		pDef CATSTR pDef, <, >, <&protoDef>
	ENDIF
	IFDEF curClass
		sz2 CATSTR <_>, curClass, <_&name_method>	;; _curClass_method
	ELSE
		sz2 CATSTR <_>, <_&name_method>
	ENDIF
	% &sz2 &pDef
;;	% echo &sz2 &pDef
	% sz1 typedef PTR &sz2
	% name_method sz1 ?
ENDM

sSpisok struct ;(sizeof=8, align=4)
	pFirst				dword ?				;//    
	pLast				dword ?				;//    
sSpisok ends

createSpisok MACRO nameSpisok:req, typeSpisok:req, args:vararg
LOCAL strTmp1, strTmp2
	strTmp1		TEXTEQU <>
	strTmp2		TEXTEQU <>
	strTmp1		CATSTR <autogenerate??for?>,<nameSpisok>,<??begin>
	strTmp2		CATSTR <autogenerate??for?>,<nameSpisok>,<??end>
	.data
	align 4
	strTmp1		typeSpisok	args
	strTmp2		label		typeSpisok
	align 4
	nameSpisok	sSpisok { offset strTmp1, offset strTmp2[-type(typeSpisok)] }
	.code
	EXITM <>
ENDM


;;  	   ,   end start
main_startup3_END MACRO
mainCRTStartup proc C
local argc:dword, argv:ptr, environ:ptr, StartInfo:_startupinfo
	and		StartInfo.newmode, 0
	__getmainargs(&argc, &argv, &environ, 0, &StartInfo)
	.if (eax==0)
		main(argc, argv, environ)
	.endif
	push	eax
	call	_exit	;;_noreturn
mainCRTStartup endp
end mainCRTStartup
ENDM

;;  	   ,   end start
main_startup0_END MACRO
mainCRTStartup proc
	main()
	push	eax
	call	_exit	;;_noreturn
mainCRTStartup endp
end mainCRTStartup
ENDM

;;  	   ,   end start
main_startup_Win32_END MACRO
mainCRTStartup proc
	;;WinMain( GetModuleHandle(NULL), NULL, GetCommandLine(), SW_SHOWDEFAULT );
	push	SW_SHOWDEFAULT	;;nCmdShow
	invoke	GetCommandLine
	push	eax				;;lpCmdLine
	push	NULL			;;hPrevInstance
	invoke	GetModuleHandle, NULL
	push	eax				;;hInstance
	call	WinMain	;;int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
	push	eax
	call	_exit	;;_noreturn
mainCRTStartup endp
end mainCRTStartup
ENDM